if 0

shd_monte_c:
;in  - esi - stencil buff ptr; this buff determines front faces of object
;      edi - shd buff - one dword pixel - every light -> byte

       push     ebp
       mov      ebp,esp
       sub      esp,110
       and      ebp,-16

       .ray     equ  [ebp-16]
       .lenght  equ  [ebp-32]
       .org     equ  [ebp-32-16]
       .msk     equ  [ebp-64]
       .l_cnt   equ  [ebp-68]



       movzx    eax,[x_res]
       movzx    ebx,[y_res]
       mov      ecx,eax
       imul     ecx,ebx
       shl      ecx,4
 ;      mov      edx,point_light_coords
       movaps   xmm5,[zero_hgst_dd]
       movaps   .msk,xmm5  ; shorter address in loop

     .l_main:

       cmp      dword[esi],60000.1  ; floor
       je       .end_main

       mov      .l_cnt,0  ; light counter
       mov      edx,point_light_coords
    .l2:
       xorps    xmm2,xmm2
       cvtsi2ss xmm0,eax
       cvtsi2ss xmm1,ebx
       movhps   xmm2,[esi]
       pslldq   xmm1,4
       por      xmm2,xmm1
       por      xmm2,xmm0
       movaps   xmm6,[edx]
       subps    xmm6,xmm2
       movaps   xmm5,xmm6
       dpps     xmm5,xmm5,01110111b

;       mulps    xmm5,xmm5
;       andps    xmm5,.msk
;       haddps   xmm5,xmm5
;       haddps   xmm5,xmm5
       sqrtss   xmm4,xmm5
       rsqrtps  xmm5,xmm5
       movss    .lenght,xmm4
       movaps   xmm0,[edx]
       mulps    xmm6,xmm5
       andps    xmm6,.msk
       movaps   .ray,xmm6
       movaps   .org,xmm2
 ;      movss    .lenght,xmm6
       push     esi
       push     eax
       push     ebx
       push     ecx
       push     edx

       movzx    ecx,[triangles_count_var]
       mov      esi,triangles
     .ll:
       movzx    eax,word[esi]
       movzx    ebx,word[esi+2]
       movzx    edx,word[esi+4]
       add      eax,eax
       add      ebx,ebx
       add      edx,edx
       lea      eax,[eax*3]
       lea      ebx,[ebx*3]
       lea      edx,[edx*3]
       add      eax,points_rotated
       add      ebx,points_rotated
       add      edx,points_rotated
       movups   xmm2,[eax]
       movups   xmm3,[ebx]
       movups   xmm4,[edx]
       movaps   xmm0,.ray
       movaps   xmm1,.org
       movss    xmm6,.lenght
       mov      eax,1
       push     ecx
       push     esi
       call     intersect_tri
       pop      esi
       pop      ecx
       cmp      eax,1
       je       .yes_shd
       add      esi,6
       loop     .l1



       jmp      .end_main:




     .yes_shd:
        xor    ebx,ebx
        mov    ecx,.l_cnt
        shl    ecx,3
        mov    bl,0xff
        shl    ebx,cl
        or     [edi],ebx    ; mark at buff


     .end_main:


end if

if 0
intersect_tri: ; Moeller-Trumbore method
; in:
;     xmm0 - ray direction  ; should be normalized
;     xmm1 - ray orgin
;     xmm2 - tri vert1
;     xmm3 - tri vert2
;     xmm4 - tri vert3
;     if  eax = 1 - intersction with edge
;        xmm6 - edge lenght
;     if  eax = 0 - intersect with ray (classic)
; out:
;     eax  = 1 - intersection occured
;     xmm0 - float lo -> hi = t, v, u, ...
      push    ebp
      mov     ebp,esp
      and     ebp,-16
      sub     esp,220

       .dir    equ [ebp-16]
       .origin equ [ebp-32]
       .ta     equ [ebp-48]
       .tb     equ [ebp-64]
       .tc     equ [ebp-80]
       .tvec   equ [ebp-96]
       .pvec   equ [ebp-112]
       .qvec   equ [ebp-128]
       .e1     equ [ebp-128-16]
       .ift    equ dword[ebp-152]
       .invdet equ [ebp-156]
       .det    equ [ebp-160]
       .ed_l   equ [ebp-164]
       .u      equ [ebp-168]
       .v      equ [ebp-172]
       .t      equ [ebp-176]
       .e2     equ [ebp-192]

      movaps   .dir,xmm0
      movaps   .origin,xmm1
      movaps   .ta,xmm2
      movaps   .tb,xmm3
      movaps   .tc,xmm4
      mov      .ift,eax
      movss    .ed_l,xmm6
      subps    xmm3,xmm2
      subps    xmm4,xmm2
      andps    xmm3,[zero_hgst_dd]
      andps    xmm4,[zero_hgst_dd]
      movaps   .e1,xmm3
      movaps   .e2,xmm4

      lea      esi,.dir
      lea      edi,.e2
      lea      ebx,.pvec
      call     cross_aligned

      movaps   xmm0,.e1
      mulps    xmm0,.pvec
 ;     andps    xmm0,[zero_hgst_dd]
      haddps   xmm0,xmm0
      haddps   xmm0,xmm0
      movss    .det,xmm0
;      cmpnless xmm0,[eps]
;      movd     eax,xmm0
;      or       eax,eax
;      jz       @f
      comiss   xmm0,[eps]
      jb       @f

      rcpss    xmm0,.det
      movss    .invdet,xmm0

      movaps   xmm0,.origin
      subps    xmm0,.ta
      andps    xmm0,[zero_hgst_dd]
      movaps   .tvec,xmm0

      mulps    xmm0,.pvec
      haddps   xmm0,xmm0
      haddps   xmm0,xmm0
      mulss    xmm0,.invdet
      movss    xmm1,xmm0
      movss    .u,xmm0
      cmpnless xmm1,[epsone]
      cmpnless xmm0,[epsminus]
      pxor     xmm1,xmm0
      movd     eax,xmm1
      or       eax,eax
      jz       @f

      lea      esi,.tvec
      lea      edi,.e1
      lea      ebx,.qvec
      call     cross_aligned

      movaps   xmm0,.dir
      mulps    xmm0,.qvec
      haddps   xmm0,xmm0
      haddps   xmm0,xmm0
      mulss    xmm0,.invdet
      movss    .v,xmm0
      movss    xmm1,xmm0
      addss    xmm1,.u
      cmpnless xmm1,[epsone]
      cmpnless xmm0,[epsminus]
      pxor     xmm1,xmm0
      movd     eax,xmm1
      or       eax,eax
      jz       @f

      movaps   xmm1,.e2
      mulps    xmm1,.qvec
      haddps   xmm1,xmm1
      haddps   xmm1,xmm1
      mulss    xmm1,.invdet
      movss    .t,xmm1
   ;   cmpnless xmm1,[eps]
   ;   movmskps eax,xmm1
   ;   test     eax,1
   ;   jz       @f
      comiss   xmm1,[eps]
      jb       @f

      mov      eax,1
      cmp      .ift,0
      je       .end       ; ok intersect occured, no edge cause

      movss    xmm0,.t      ; else check with edge lenght
    ;  movss    xmm1,.t
      cmpnless xmm0,[eps]
      cmpnless xmm1,.ed_l
      xorps    xmm0,xmm1
      movd     ebx,xmm0
      or       ebx,ebx
      jz       @f

 ;     mov      eax,1
 ;     movaps   xmm0,.t
      jmp      .end
   @@:
      xor      eax,eax
    .end:
      movaps   xmm0,.t
      add      esp,220
      pop      ebp
ret

end if



normalize_object1:  ; procedure don't save registers !!

        .points_count equ ebp+4
        .points_r     equ ebp+8

     ;  push  ebp
       mov    ebp,esp

       xor    ebx,ebx
       xorps  xmm7,xmm7    ;xmm7 - maxxx, max of all maxes
    .find_again_min_max:
       mov    ecx,[.points_count]
       dec    ecx
       mov    edi,[.points_r]
       movss  xmm0,dword[edi+ebx]
       movss  xmm1,dword[edi+ebx]
     @@:
       maxss  xmm0,dword[edi+ebx+12]    ; xmm0 - max
       minss  xmm1,dword[edi+ebx+12]    ; xmm1 - min

       add    edi,12
       loop   @b

       addss  xmm0,xmm1             ; xmm0 - substraction
       mov    eax,2
       cvtsi2ss xmm2,eax
       divss  xmm0,xmm2             ; xmm0 - center



       mov    edi,[.points_r]
       mov    ecx,[.points_count]
    @@:
       movss  xmm2,[edi+ebx]   ; xmm0 - center
       subss  xmm2,xmm0
       movss  [edi+ebx],xmm2
       maxss  xmm7,xmm2        ; xmm7 - maximum of all
       add    edi,12           ; cooficientes
       loop   @b
       add    ebx,4
       cmp    ebx,12
       jne    .find_again_min_max

       mov    edi,[.points_r]
       mov    ecx,[.points_count]
       rcpss  xmm7,xmm7
       shufps xmm7,xmm7,0
     @@:
       movups xmm6,[edi]
       mulps  xmm6,xmm7
       movlps [edi],xmm6
       psrldq xmm6,8
       movss  [edi+8],xmm6
       add    edi,12
       loop   @b

       mov    esp,ebp
     ;  pop    ebp
ret 8


calc_bumpmap:
; calculate bumpmap texture dependent
;--------------in edi - pointer to TEX_X x TEX_Y bumpmap
;              in esi - pointer to texture

         push    ebp
         mov     ebp,esp

         .bmap   equ [ebp-4]
         .tex    equ [ebp-8]

         push    edi
         push    esi

         mov     edi,.bmap
         mov     esi,.tex
         cld
         mov     ecx,TEX_SIZE
      @@:
         xor    eax,eax
         lodsb
         mov     bx,ax
         lodsb
         add     bx,ax
         lodsb
         add     bx,ax
         movsx   eax,bx
         cdq
    ;     shr     ax,1
         div     [i3]
         inc     esi
         stosb
         loop    @b




         mov    edi,.bmap
         mov    ecx,2
      .blur:
         push   ecx
         xor    esi,esi
         mov    ecx,TEX_SIZE
         xor    eax,eax
         xor    ebx,ebx
      @@:
         push   ecx
         mov    edx,esi
         dec    edx
         and    edx,TEX_SIZE
         mov    al,byte[edx+edi]

         mov    edx,esi
         inc    edx
         and    edx,TEX_SIZE
         mov    bl,byte[edx+edi]
         add    eax,ebx

         mov    edx,esi
         sub    edx,TEX_Y
         and    edx,TEX_SIZE
         mov    bl,byte[edx+edi]
         add    eax,ebx

         mov    edx,esi
         add    edx,TEX_Y
         and    edx,TEX_SIZE
         mov    bl,byte[edx+edi]
         add    eax,ebx

         shr    eax,2
         mov    byte[esi+edi],al

         inc    esi
         pop    ecx
         loop   @b
         pop    ecx
         loop   .blur

         mov    esp,ebp
         pop    ebp

ret

if 0
random:
;  in  - ecx - min
;        edx - max
;  out - eax - random number
         mov    bx,[rand_seed]
         add    bx,0x9248
         ror    bx,3
         mov    [rand_seed],bx

         mov    ax,dx
         sub    ax,cx
         mul    bx
         mov    ax,dx
         add    ax,cx
         cwde
ret

end if